Description

When configured with two or more intervals, the highest interval does not like the part window marked as dirty.
To reproduce this, | added the following code to a partModule:

[KSPField(isPersistant = false, guiActiveEditor = true, guiName = "testField", guiFormat = "0.000"
, guilUnits = "")]

[UI_ScaleEdit (scene = UI_Scene.Editor)]

public float testField = 1;

public override void OnStart (StartState state)

{
1/

var range = (UI_ScaleEdit)Fields["testField"].uiControlEditor;
float([] a = { 1f, 2f, 3f };
float[] b = { 0.01f, 0.01f };

range.intervals = a;
range.incrementSlide = b;
range.sigFigs = 3;
}
[KSPEvent (guiActive = true, guiActiveEditor = true, guiName = "Debug") ]

public void debugOutput ()
{
Debug.Log ("testFieldl =" +testField.ToString());
}
[KSPEvent (guiActive = true, guiActiveEditor = true, guiName = "UpdateWindow") ]
public void updateWindow ()
{
Debug.Log ("updateWindow") ;
foreach (var win in FindObjectsOfType<UIPartActionWindow> () .Where (win => win.part == part))
{

win.displayDirty = true;
}
Reproduction:

® go to the editor

e take a part with your module

¢ open debug log

¢ tweak testField to 2.5, press 'Debug’
=> log says "testField=2.5", slider says "2.5" (ok)

¢ press "updateWindow"
=> glider jumps to 100% and says "2.0" (not ok, should stay at 50% and "2.5")
It looks like the tweakable decides to display the wrong interval.

e press "debug"
=> log says "testField=2.5" (ok, but shows that the Ul is not consistent with the internal value)
If the window ends up marked as dirty after every button press, then this behaviour makes the highest interval pretty much unusable.

Workaround: add a dummy interval.

History

#1 - 07/17/2016 09:56 AM - TriggerAu

- Status changed from New to Needs Clarification

#2 - 08/21/2016 11:26 AM - pellinor
- Status changed from Needs Clarification to Updated
- % Done changed from 0 to 10

Still presentin 1.1.3

#3 - 09/23/2016 09:27 PM - pellinor
Still present in 1.2.0.1523
